val fromto: int -> int -> int list
val merge_and_unify: ('a -> 'a -> int) -> 'a list -> 'a list -> 'a list
val merge: ('a -> 'a -> int) -> 'a list -> 'a list -> 'a list

(*** makepairs [a1;...;an] [b1;...;bm]) = [(a1,b1);...;(a1,bm);...(an,b1);...;(an,bm)] ***)
val make_pairs: 'a list -> 'b list -> ('a * 'b) list
val list_flatten: 'a list list -> 'a list
val id: 'a -> 'a
val delete_duplication: 'a list -> 'a list
val delete_duplication_unsorted: 'a list -> 'a list
val delete_duplication2: ('a -> 'a -> int) -> ('a -> 'a -> 'a) -> 'a list -> 'a list
val list_assoc2: 'a -> ('a*'b) list -> 'b * ('a * 'b) list
val list_diff: 'a list -> 'a list -> 'a list
val list_last: 'a list -> 'a
val swap: 'a * 'b -> 'b * 'a

type ('a, 'b) substitution = ('a * 'b) list
val subst_empty: ('a, 'b) substitution
val make_subst: 'a -> 'b -> ('a, 'b) substitution
val list2subst: ('a * 'b) list -> ('a,'b) substitution
val comp_subst: (('a, 'b) substitution -> 'b -> 'b) ->
                    ('a, 'b) substitution -> ('a,'b) substitution-> ('a,'b) substitution
val subst_var: ('a,'b) substitution -> 'a -> 'b -> 'b

type ('a, 'b) env
val env_lookup: 'a -> ('a, 'b) env -> 'b
val env_empty: ('a, 'b) env
val env_extend: 'a -> 'b -> ('a,'b) env -> ('a,'b) env
val env_map: ('b -> 'c) -> ('a,'b) env -> ('a,'c) env
val print_env: ('a -> string) -> ('b -> string) -> ('a,'b) env -> unit
val env2list: ('a, 'b) env -> ('a * 'b) list
val list2env: ('a * 'b) list -> ('a, 'b) env  

(*** perfect_matching checks to see if there exists a perfect matching 
 *** in a bi-partite graph.
 ***)
val perfect_matching: 'a list -> 'b list -> ('a * 'b) list -> bool